<!-- eslint-disable vue/no-v-html -->
<template>
  <div
    :class="{
      'lock': $store.state.lockEditor
    }" class="editor"
  >
    <info-box
      v-if="$store.state.debugMode"
      :time="realTime"
      :musical-time="musicalTime"
      :cursor-position="mousePosition"
      :signature="piece.signature"
      :second-unit="currentTrack.secondUnit"
      :selected-label="actions.getSelected()"
    />
    <canvas-switcher
      v-slot="{ source: unscaledSource, index, scale, snappableWave }"
      ref="canvas-switcher"
      :sources="piece.sources"
      class="editor-body"
      :default-sources="defaultSources"
      @set-youtube-track="setYoutubeTrack"
    >
      <source-scaler
        v-slot="{ source }"
        :source="unscaledSource"
        :scale="scale.value"
      >
        <!-- The scroll container, sends scroll events and can order scrolls -->
        <!-- Passes the view rectangle and the scroll function to its children -->
        <!-- Here we only listen to the events of the first scroller -->
        <canvas-scroller
          :has-minimap="source.type === '3d' ? false : true"
          :auto-zoom="source.type === '3d'"
          :zoom.sync="source.zoom"
          :width="source.width"
          :pixel-unit="source.pixelUnit"
          :style="`${source.type === '3d' ? 'height: 100%; overflow-y: hidden' : ''}`"
        >
          <template #timeline="{ viewRect }">
            <canvas-timeline
              ref="canvas-timeline"
              :source="source"
              :zoom="source.zoom.value"
              :musical-quality="piece.musicalQuality"
            >
              <template #default="{ width, pixelUnit, displayedTimelines, positions }">
                <canvas-timeline-musical
                  v-if="displayedTimelines.musical"
                  :y="positions.musical"
                  :zoom="source.zoom.value"
                  :signature="piece.signature"
                  :width="width"
                  :pixel-unit="pixelUnit"
                  :view-rect="viewRect"
                />
                <canvas-timeline-date
                  v-if="currentTrack && displayedTimelines.date"
                  :y="positions.date"
                  :zoom="source.zoom.value"
                  :width="width"
                  :pixel-unit="pixelUnit"
                  :second-unit="currentTrack.secondUnit"
                  :view-rect="viewRect"
                />
              </template>
            </canvas-timeline>
          </template>
          <!-- The API provider by the scroller component -->
          <template #default="{ viewRect, actions: { goTo, goToRange } }">
            <!-- The canvas, displays data passed in props and emit events -->
            <label-canvas
              :get-label="(id) => analysis ? actions.getLabel(id) : null"
              :sorted-labels="analysis ? actions.getSortedLabels(source.type) : []"
              :selected-id="analysis ? actions.selectedId : null"
              :is-focused="focusedSourceIndex === index"
              :source="source"
              :zoom="source.zoom.value"
              :show-lines="isDragging"
              :current-view-x="viewRect.x"
              @all-mousemove="(e) => onMouseMove(e)"
              @all-mouseover="focusedSourceIndex = index"
              @all-focusin="focusedSourceIndex = index"
              @label-dblclick="focusEditor()"
              @document-keydown.enter="focusEditor()"
              @document-ctrl-keydown.enter="focusEditor()"
            >
              <template #svgInjector>
                <canvas-source-base
                  :analysis="analysis"
                  :source="source"
                  :signature="piece.signature"
                  @image-mouseover="focusedSourceIndex = index"
                />
              </template>
              <!-- The behaviors, consume events and commit changes -->

              <!-- Unique behaviors (only on the first canvas) -->

              <template #default="{ canvas }">
                <b-follow-on-play
                  :canvas="canvas"
                  :scroll-to="goTo"
                  :playing="playing"
                  :view-rect="viewRect"
                />
                <template v-if="index === 1">
                  <b-zoom-on-window-resize
                    :zoom="source.zoom"
                    :canvas="canvas"
                  />
                  <b-scroll-on-target
                    v-if="visibleAnalysis"
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <b-player-control-on-key
                    v-if="currentTrack"
                    :canvas="canvas"
                    :pixel-unit="source.pixelUnit"
                    :second-unit="currentTrack.secondUnit"
                    :scroll-to="goTo"
                    :playing.sync="playing"
                    :real-time="realTime"
                    :view-rect="viewRect"
                    @update:realTime="setRealTime($event)"
                  />
                  <b-create-on-numpad
                    v-if="editableAnalysis"
                    :canvas="canvas"
                    :actions="actions"
                    :musical-time="musicalTime"
                    :signature="piece.signature"
                    :templates="analysis.templates"
                    :staves="source.staves"
                  />
                </template>

                <!-- Unique behaviors (only on focused canvas) -->
                <template v-if="index === focusedSourceIndex">
                  <b-send-onset-on-scroll
                    :pixel-unit="source.pixelUnit"
                    :view-rect="viewRect"
                    @scroll-onset="(s) => scrollSync = s"
                  />
                  <b-zoom-on-ctrl-scroll
                    :zoom="source.zoom"
                    :canvas="canvas"
                  />
                  <template v-if="editableAnalysis">
                    <b-copy-paste-on-key
                      :canvas="canvas"
                      :actions="actions"
                      :musical-time="musicalTime"
                      :playing="playing"
                      :staves="source.staves"
                    />
                    <b-delete-on-key
                      :canvas="canvas"
                      :actions="actions"
                    />
                  </template>
                  <template v-if="visibleAnalysis">
                    <b-prev-next-on-key
                      :canvas="canvas"
                      :actions="actions"
                    />
                  </template>
                  <!-- alt-ctrl-zoom to scale left-right -->
                  <b-zoom-on-ctrl-scroll
                    v-if="!source.shouldSnap"
                    :zoom="scale"
                    :canvas="canvas"
                    use-alt
                  />
                  <b-scroll-on-key
                    :canvas="canvas"
                    :scroll-to="goTo"
                    :pixel-unit="source.pixelUnit"
                    :current-position="viewRect.x"
                  />
                  <b-toggle-raw-times-on-key :canvas="canvas" />
                </template>

                <!-- Per canvas behaviors -->
                <b-update-repeat-on-key
                  :canvas="canvas"
                  @incr="updateRepeat(1)"
                  @decr="updateRepeat(-1)"
                />
                <b-switch-timeline-on-key
                  :canvas="canvas"
                  @switch="switchTimeline"
                />
                <template v-if="visibleAnalysis">
                  <b-select-on-click
                    :actions="actions"
                    :canvas="canvas"
                  />
                  <b-select-on-tab-focus
                    :actions="actions"
                    :canvas="canvas"
                  />
                  <b-unselect-on-canvas-click
                    :actions="actions"
                    :canvas="canvas"
                  />
                </template>
                <template v-if="editableAnalysis">
                  <b-resize-on-arrow-drag
                    :canvas="canvas"
                    :actions="actions"
                    :pixel-unit="source.pixelUnit"
                    :snap="source.shouldSnap"
                    :snappable-wave="snappableWave"
                    :pages="source.pages"
                  />
                  <b-move-on-drag
                    :canvas="canvas"
                    :actions="actions"
                    :pixel-unit="source.pixelUnit"
                    :staves="source.staves"
                    :snap="source.shouldSnap"
                    :snappable-wave="snappableWave"
                    :pages="source.pages"
                    @drag="(dragging) => isDragging = dragging"
                  />
                  <b-create-on-canvas-drag
                    :actions="actions"
                    :canvas="canvas"
                    :pixel-unit="source.pixelUnit"
                    :snap="source.shouldSnap"
                    :snappable-wave="snappableWave"
                    :pages="source.pages"
                    @drag="(dragging) => isDragging = dragging"
                  />
                </template>
                <b-seek-on-shift-click
                  v-if="currentTrack"
                  :canvas="canvas"
                  :pages="source.pages"
                  :pixel-unit="source.pixelUnit"
                  @update:realTimeSync="setRealTime($event)"
                  @update:time="setTime($event)"
                />
                <b-seek-and-play-on-double-click
                  v-if="currentTrack"
                  :canvas="canvas"
                  :pages="source.pages"
                  :pixel-unit="source.pixelUnit"
                  :playing.sync="playing"
                  @update:realTimeSync="setRealTime($event)"
                  @update:time="setTime($event)"
                />
                <b-play-label-on-shift-dbl-click
                  v-if="currentTrack && visibleAnalysis"
                  :canvas="canvas"
                  :pixel-unit="source.pixelUnit"
                  :playing.sync="playing"
                  :musical-time="musicalTime"
                  :offset-margin="piece.signature.increment"
                  :actions="actions"
                  @update:musicalTime="setTime($event)"
                />
                <!-- Precise cursor always on for spectrograms -->
                <!-- Precise cursor only on for score if usePreciseCursor is true -->
                <b-canvas-cursor
                  v-if="
                    (source.type !== 'score' && source.type !== '3d' && source.type !== 'grid')
                      || (usePreciseCursor && piece.audioQuality > 3)
                  "
                  :by-measure="['3d', 'grid'].includes(source.type)"
                  :pages="source.pages"
                  :canvas="canvas"
                  :pixel-unit="source.pixelUnit"
                  :musical-time="musicalTime"
                  :real-time="realTime"
                  :is-different-track="source.track !== currentTrack"
                  :signature="source.signature"
                  :in-measure-cursor="
                    ['score', '3d', 'grid'].includes(source.type)
                      && (usePreciseCursor && piece.audioQuality > 3)
                  "
                />
                <b-scroll-to-cursor-on-key
                  :canvas="canvas"
                  :pixel-unit="source.pixelUnit"
                  :musical-time="musicalTime"
                  :real-time="realTime"
                  :is-different-track="source.track !== currentTrack"
                  :scroll-to="goTo"
                />
                <!-- Measure cursor only on for scores -->
                <!-- Clicking it toggles precise cursor -->
                <b-canvas-measure-cursor
                  v-if="['score', '3d', 'grid'].includes(source.type)"
                  :canvas="canvas"
                  :pages="source.pages"
                  :is3d="['3d', 'grid'].includes(source.type)"
                  :pixel-unit="source.pixelUnit"
                  :signature="piece.signature"
                  :musical-time="musicalTime"
                  @click.exact.native="usePreciseCursor = !usePreciseCursor"
                />
                <b-scroll-on-load
                  :pixel-unit="source.pixelUnit"
                  :start-onset="scrollSync"
                  :scroll-to="goTo"
                />
                <b-scroll-to-label
                  v-if="visibleAnalysis"
                  :pixel-unit="source.pixelUnit"
                  :scroll-to-range="goToRange"
                  :canvas="canvas"
                  :actions="actions"
                />
                <b-scroll-on-edge-drag
                  :canvas="canvas"
                  :scroll-to="goTo"
                  :view-rect="viewRect"
                />
                <b-player-notifier
                  v-if="labelAudioFeedback && visibleAnalysis"
                  :canvas="canvas"
                  :actions="actions"
                  :musical-time="musicalTime"
                  :playing="playing"
                />
                <b-player-notifier-toggle-on-key
                  :canvas="canvas"
                  @update="(value) => labelAudioFeedback = value"
                />
                <b-scroll-to-start-on-key
                  :canvas="canvas"
                  :scroll-to="goTo"
                />
                <b-switch-source-on-key
                  :canvas="canvas"
                  @switch-track="changeTrack(nextTrackIndex())"
                />
              </template>
            </label-canvas>
          </template>
          <!-- The minimap scrollbar replacement -->
          <template #minimap="{ viewRect, actions: { goTo } }">
            <minimap
              v-if="source.type !== 'grid'"
              v-slot="{ canvas }"
              :sorted-labels="analysis ? actions.getSortedLabels() : []"
              :source="source"
              :go-to="goTo"
              :view-rect="viewRect"
              :show-image="piece.settings['score-minimap']"
            >
              <b-canvas-cursor
                :pages="source.pages"
                :pixel-unit="source.pixelUnit"
                :musical-time="musicalTime"
                :real-time="realTime"
                :is-different-track="source.track !== currentTrack"
              />
              <b-seek-on-shift-click
                v-if="currentTrack"
                :canvas="canvas"
                :pages="source.pages"
                :pixel-unit="source.pixelUnit"
                @update:realTimeSync="setRealTime($event)"
                @update:time="setTime($event)"
              />
            </minimap>
          </template>
        </canvas-scroller>
      </source-scaler>
    </canvas-switcher>
    <!-- The editor bar and player container -->
    <analysis-tools
      ref="editor-tools"
      :visible-analysis="visibleAnalysis"
      :piece="piece"
      :analysis="analysis"
      :actions="actions"
      :playing="playing"
      :musical-time="musicalTime"
    >
      <template #player>
        <!-- The audio player. Warning: -->
        <!-- Changing musicalTime or realTime will not affect player -->
        <!-- You need to call setMusicalTime -->
        <div class="ma-3 d-flex">
          <dez-fab
            v-if="piece.tracks.length > 1"
            btn-id="switch-track-button"
            :tooltip="getTrackInfo()"
            icon="mdi-rotate-3d-variant"
            :color="$store.state.secondaryColor"
            @click="changeTrack(nextTrackIndex())"
          />
          <v-btn
            v-show="showRepeat"
            style="margin: 5px;height: 56px;width: 56px;"
            fab
            btn-id="repeat-button"
            tooltip=""
            :color="$store.state.secondaryColor"
            :disabled="currentRepeat === 'null'"
            @click="changeRepeat"
          >
            <span class="text-h5">{{ currentRepeat !== 'null' ? currentRepeat : '' }}</span>
          </v-btn>
        </div>
        <player-container
          ref="player"
          v-model="playing"
          :audio="currentTrack"
          :musical-time.sync="musicalTime"
          :real-time.sync="realTime"
          :clean.sync="isClean"
          :last-onset.sync="lastOnsetBeforeSwitch"
          :start-second="getTrackStart"
        />
        <div v-if="$store.state.debugMode || !editableAnalysis" class="tracks-container">
          <div
            v-for="(t, index) in piece.tracks" :key="index"
            class="tracks-selector"
            :class="{
              'active': trackIndex === index
            }"
            @keydown="() => {}"
            @click="changeTrack(index)"
            v-html="t.getInfo()"
          />
        </div>
      </template>
    </analysis-tools>
    <!-- Generate CSS from types and tags -->
    <!-- Avoids any state in labels -->
    <color-generator
      v-if="analysis"
      :analysis="analysis"
      :actions="actions"
    />
  </div>
</template>
<script lang="ts">
import {
  Vue, Component, Watch, Ref, Prop, PropSync,
} from 'vue-property-decorator';
import LabelCanvas from '@/components/canvas/LabelCanvas.vue';
import Minimap from '@/components/canvas-addons/Minimap.vue';

// Behaviors
import BUpdateRepeatOnKey from '@/components/behaviors/player/BUpdateRepeatOnKey.vue';
import BSelectOnClick from '@/components/behaviors/shared/BSelectOnClick.vue';
import BCopyPasteOnKey from '@/components/behaviors/shared/BCopyPasteOnKey.vue';
import BDeleteOnKey from '@/components/behaviors/shared/BDeleteOnKey.vue';
import BUnselectOnCanvasClick from '@/components/behaviors/shared/BUnselectOnCanvasClick.vue';
import BSelectOnTabFocus from '@/components/behaviors/shared/BSelectOnTabFocus.vue';
import BPrevNextOnKey from '@/components/behaviors/shared/BPrevNextOnKey.vue';
import BResizeOnArrowDrag from '@/components/behaviors/analysis/BResizeOnArrowDrag.vue';
import BMoveOnDrag from '@/components/behaviors/analysis/BMoveOnDrag.vue';
import BCreateOnCanvasDrag from '@/components/behaviors/analysis/BCreateOnCanvasDrag.vue';
import BCreateOnNumpad from '@/components/behaviors/analysis/BCreateOnNumpad.vue';
import BSeekOnShiftClick from '@/components/behaviors/player/BSeekOnShiftClick.vue';
import BSeekAndPlayOnDoubleClick from '@/components/behaviors/player/BSeekAndPlayOnDoubleClick.vue';
import BPlayLabelOnShiftDblClick from '@/components/behaviors/player/BPlayLabelOnShiftDblClick.vue';
import BPlayerControlOnKey from '@/components/behaviors/player/BPlayerControlOnKey.vue';
import BCanvasCursor from '@/components/behaviors/player/BCanvasCursor.vue';
import BCanvasMeasureCursor from '@/components/behaviors/player/BCanvasMeasureCursor.vue';
import BFollowOnPlay from '@/components/behaviors/player/BFollowOnPlay.vue';
import BSendOnsetOnScroll from '@/components/behaviors/scroll/BSendOnsetOnScroll.vue';
import BScrollOnLoad from '@/components/behaviors/scroll/BScrollOnLoad.vue';
import BScrollOnEdgeDrag from '@/components/behaviors/scroll/BScrollOnEdgeDrag.vue';
import BScrollToLabel from '@/components/behaviors/scroll/BScrollToLabel.vue';
import BScrollOnTarget from '@/components/behaviors/scroll/BScrollOnTarget.vue';
import BZoomOnCtrlScroll from '@/components/behaviors/zoom/BZoomOnCtrlScroll.vue';
import BZoomOnWindowResize from '@/components/behaviors/zoom/BZoomOnWindowResize.vue';
import BMinimapCursor from '@/components/behaviors/scroll/BMinimapCursor.vue';
import BMinimapClickScroll from '@/components/behaviors/scroll/BMinimapClickScroll.vue';
import BPlayerNotifier from '@/components/behaviors/player/BPlayerNotifier.vue';
import BPlayerNotifierToggleOnKey from '@/components/behaviors/player/BPlayerNotifierToggleOnKey.vue';
import BScrollToStartOnKey from '@/components/behaviors/scroll/BScrollToStartOnKey.vue';
import BSwitchSourceOnKey from '@/components/behaviors/player/BSwitchSourceOnKey.vue';
import BScrollToCursorOnKey from '@/components/behaviors/scroll/BScrollToCursorOnKey.vue';
import BSwitchTimelineOnKey from '@/components/behaviors/player/BSwitchTimelineOnKey.vue';
import BScrollOnKey from '@/components/behaviors/scroll/BScrollOnKey.vue';

// Addons

import CanvasSwitcher from '@/components/canvas-switchers/CanvasSwitcher.vue';
import CanvasScroller from '@/components/canvas-addons/CanvasScroller.vue';
import SourceScaler from '@/components/canvas-addons/SourceScaler.vue';
import AnalysisTools from '@/components/toolbars/AnalysisTools.vue';
import ColorGenerator from '@/components/canvas-addons/ColorGenerator.vue';
import PlayerContainer from '@/components/players/PlayerContainer.vue';
import CanvasTimeline from '@/components/canvas/CanvasTimeline.vue';
import CanvasTimelineMusical from '@/components/canvas/CanvasTimeline/CanvasTimelineMusical.vue';
import CanvasTimelineDate from '@/components/canvas/CanvasTimeline/CanvasTimelineDate.vue';

import DezFab from '@/vuejs/components/utils/DezFab.vue';

// Logic

import type AnalysisActions from '@/logic/AnalysisActions';
import type {
  Analysis, Piece, Onset, Audio, Second, Source,
} from '@/data';
import AnalysisActionsImpl from '@/logic/AnalysisActionsImpl';
import type { Position } from 'vue-router/types/router';
import CanvasSourceBase from '@/components/canvas-sources/CanvasSourceBase.vue';
import type ITools from './toolbars/ITools';
import type IPlayerContainer from './players/IPlayerContainer';
import BToggleRawTimesOnKey from './behaviors/shared/BToggleRawTimesOnKey.vue';
import InfoBox from './canvas-addons/InfoBox.vue';

/**
 * The main dezrann integration
 *
 * Displays a piece analysis and lets a user modify it
 */
@Component({
  components: {
    CanvasSourceBase,
    InfoBox,
    // All the canvas behaviors used
    BUpdateRepeatOnKey,
    BSelectOnClick,
    BCopyPasteOnKey,
    BDeleteOnKey,
    BUnselectOnCanvasClick,
    BSelectOnTabFocus,
    BResizeOnArrowDrag,
    BMoveOnDrag,
    BCreateOnCanvasDrag,
    BCreateOnNumpad,
    BSeekOnShiftClick,
    BSeekAndPlayOnDoubleClick,
    BPlayLabelOnShiftDblClick,
    BCanvasCursor,
    BCanvasMeasureCursor,
    BPlayerControlOnKey,
    BFollowOnPlay,
    BSendOnsetOnScroll,
    BScrollOnEdgeDrag,
    BScrollOnLoad,
    BScrollToLabel,
    BScrollOnTarget,
    BPrevNextOnKey,
    BZoomOnCtrlScroll,
    BZoomOnWindowResize,
    BPlayerNotifier,
    BPlayerNotifierToggleOnKey,
    BScrollToStartOnKey,
    BSwitchSourceOnKey,
    BScrollToCursorOnKey,
    BSwitchTimelineOnKey,
    BScrollOnKey,
    BToggleRawTimesOnKey,

    // All the minimap behaviors used
    BMinimapCursor,
    BMinimapClickScroll,

    // All the canvas add-ons and UI tools
    CanvasTimeline,
    CanvasTimelineMusical,
    CanvasTimelineDate,
    CanvasScroller,
    CanvasSwitcher,
    LabelCanvas,
    Minimap,
    ColorGenerator,
    AnalysisTools,
    SourceScaler,
    PlayerContainer,
    DezFab,
  },
})
export default class AnalysisEditor extends Vue {
  // Main states

  @Prop()
  analysis!: Analysis;

  @Prop()
  piece!: Piece;

  @Prop({ default: true })
  editableAnalysis!: boolean;

  @Prop({ default: true })
  visibleAnalysis!: boolean;

  @PropSync('clean', { default: true, required: false })
  isClean!: boolean;

  trackIndex = 0;

  actions: AnalysisActions = {} as AnalysisActions;

  // appZoom = new Zoom();

  // Sub states

  created() {
    this.trackIndex = 0;
    this.resetPiece();
  }

  // Anything that should be reset if the piece changes
  @Watch('piece')
  resetPiece() {
    this.resetTrack();
    this.player?.reset();
    this.resetAnalysis();
  }

  getTrackInfo() {
    const num = `${this.trackIndex + 1}/${this.piece.tracks.length}`;
    const info = this.piece?.tracks[this.trackIndex]?.getInfoShort();
    return `${num}. ${info}`;
  }

  setYoutubeTrack(track: Audio) {
    if (!this.piece.tracks) return;

    if (!this.piece.tracks[this.trackIndex].youtubeId) return;

    this.trackIndex = this.piece.tracks
      .findIndex((t) => t.youtubeId === track.youtubeId);
  }

  lastOnsetBeforeSwitch: Onset | null = 0 as Onset;

  goToCurrentOnset() {
    this.lastOnsetBeforeSwitch = this.piece.tracks[this.trackIndex].secondUnit
      .toOnset(this.realTime as Second).value;
  }

  updateWaveForm() {
    if (this.piece.tracks[this.trackIndex].youtubeId) {
      this.canvasSwitcher.updateWaveform(this.piece.tracks[this.trackIndex]);
    }
  }

  nextTrackIndex() {
    return (this.trackIndex + 1) % this.piece.tracks.length;
  }

  changeTrack(index: number) {
    if (!this.piece.tracks) return;
    this.goToCurrentOnset();
    this.trackIndex = index;
    this.updateWaveForm();
  }

  @Watch('trackIndex')
  async resetTrack() {
    const musicalTimeSave = this.musicalTime ?? 0 as Onset;

    this.currentTrack = this.piece.tracks[this.trackIndex] ?? null;
    await Vue.nextTick();
    this.setTime(musicalTimeSave);
    this.ripple();
  }

  ripple() {
    const playButton = document.getElementById('switch-track-button');
    if (playButton) {
      const offset = playButton.getBoundingClientRect();

      const ev = new MouseEvent('mousedown', {
        clientX: offset.left + offset.width / 2,
        clientY: offset.top + offset.height / 2,
      });
      playButton.dispatchEvent(ev);

      setTimeout(() => {
        playButton.dispatchEvent(new MouseEvent('mouseup'));
      }, 1);
    }
  }

  // Anything that should be reset if only the analysis changes
  @Watch('analysis')
  resetAnalysis() {
    if (this.analysis) {
      this.actions = new AnalysisActionsImpl(this.piece, this.analysis);
    }
  }

  @Watch('actions.editCount')
  onEdit() {
    if (this.isClean !== !this.actions.editCount) {
      this.isClean = !this.actions.editCount;
    }
  }

  @Watch('actions.selectCount')
  onSelect() {
    const label = this.actions.getSelected();

    if (label) this.actions?.setTemplate(label);
  }

  /** The index of the last focused source */
  focusedSourceIndex = 1;

  // Audio management

  // The current playing track
  currentTrack: Audio | null = null;

  // If the selected player is playing
  playing = false;

  @Ref('canvas-switcher')
  canvasSwitcher!: CanvasSwitcher;

  @Ref('editor-tools')
  editor!: ITools;

  @Ref('player')
  player?: IPlayerContainer;

  setTime(time: Onset) {
    this.player?.setMusicalTime(time);
  }

  setRealTime(time: Second) {
    this.player?.setRealTime(time);
  }

  focusEditor() {
    this.editor.focus();
  }

  switchTimeline() {
    const ref = this.$refs['canvas-timeline'] as CanvasTimeline;
    if (ref) {
      ref.toggleTimeline();
    }
  }

  labelAudioFeedback = false;

  // Used
  usePreciseCursor = true;

  // The current time of the player
  // Current time should never be set, except to null
  // It is exclusively updated by the player
  // To change it, use setTime on any player
  readonly musicalTime: Onset | null = null;

  readonly realTime: Second | null = null;

  // Are we currently dragging a label
  isDragging = false;

  // Scroll url loading and updating

  @PropSync('scroll')
  scrollSync!: Onset | null;

  mousePosition: Position = { x: 0, y: 0 };

  onMouseMove(e: MouseEvent) {
    this.mousePosition.x = e.x;
    this.mousePosition.y = e.y;
  }

  get defaultSources(): Array<Array<Source>> {
    const ret: Array<Array<Source>> = [];
    try {
      const arr: Array<Array<number>> = this.piece.settings.panels
        ?? JSON.parse(this.$route.query.panels as string);
      arr.forEach((row, rowIndex) => {
        ret.push([]);
        if (row.length) {
          row.forEach((col, colIndex) => {
            ret[rowIndex].push(this.piece.sources[arr[rowIndex][colIndex]]);
          });
        }
      });
      return ret;
    } catch (error) {
      return [];
    }
  }

  lastRepeat = 'null';

  get showRepeat(): boolean {
    return (
      this.currentTrack?.secondUnit.repeatTables.a
        && (this.currentTrack?.secondUnit.repeatTables.a.length || 0) > 0) || false;
  }

  get currentRepeat(): string {
    this.lastRepeat = this.currentTrack?.secondUnit
      .toOnset(this.realTime || 0 as Second).repeat || 'null';
    return this.lastRepeat;
  }

  changeRepeat(e: MouseEvent) {
    this.updateRepeat(e.shiftKey ? -1 : 1);
  }

  updateRepeat(dir: number) {
    if (this.lastRepeat === 'null' && this.currentTrack === undefined) return;
    const onsetDateUnit = (this.currentTrack as Audio).secondUnit;
    const newTime = onsetDateUnit.fromOnset(
      this.musicalTime || 0 as Onset,
      onsetDateUnit.repeatBeside(this.lastRepeat, dir),
    ).value;
    if (newTime) this.setRealTime(newTime);
  }

  get getTrackStart(): number {
    return this.currentTrack?.secondUnit.fromOnset(0 as Onset).value || 0;
  }
}

</script>
<style scoped lang="scss">
.editor {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  overflow: hidden;
  &-body {
    flex-grow: 1;
    flex-shrink: 1;
    height: 0;
    overflow-y: hidden;
    min-height: 2em;
  }
  &.lock {
    pointer-events: none;
    opacity: 0.5;
  }
}

.tracks {
  &-container {
    display: flex;
    margin-right: 30px;
    flex-direction: column;
    height: 164px;
    min-width: 300px;
    max-width: 700px;
    overflow-y: auto;
    border: 0px solid #777;
  }
  &-selector {
    font-size: 12px;
    cursor: pointer;
    padding: 5px;
    color: var(--v-primary-base);
    &:hover {
      background: #bbb;
    }
    &.active {
      background: var(--v-secondary-base);
      color: white;
    }
  }
}
</style>
